-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

lib.classes["DEATHKNIGHT"] = {}

lib.classes["DEATHKNIGHT"][5] = function ()

	cfg.spells={}
	lib.AddSpell("Outbreak",{77575}) -- Outbreak
--	lib.AddSpell("melee",{6603}) -- Melee
	lib.AddSpell("ps",{45462}) -- Plague Strike
	lib.AddSpell("it",{45477}) -- Icy Touch
	lib.AddSpell("fes",{85948}) -- Festering Strike
	lib.AddSpell("ss",{55090}) -- Scourge Strike
	lib.AddSpell("dc",{47541}) -- Death Coil
	lib.AddSpell("dnd",{43265}) -- Death and Decay
	lib.AddSpell("dt",{63560}) -- Dark Transformation
	lib.AddSpell("how",{57330}) -- Horn of Winter
	lib.AddSpell("pest",{50842}) -- Pestilence
				
	cfg.auras={}
	lib.AddAura("sd",81340,"buff","player") -- Sudden Doom
	lib.AddAura("rc",51460,"buff","player") -- Runic Corruption

	lib.AddAura("si",91342,"buff","pet") -- Shadow Infusion
	lib.AddAura("dt",63560,"buff","pet") -- Dark Transformation

	lib.AddAura("bp",55078,"debuff","target") -- Blood Plague
	lib.AddAura("ff",55095,"debuff","target") -- Frost Fever
		
	local plist = {}
	table.insert(plist,"Outbreak_bp")
	table.insert(plist,"Outbreak_ff")
	table.insert(plist,"it")
	table.insert(plist,"ps")
	table.insert(plist,"dt")
	table.insert(plist,"dc_sd")
--	table.insert(plist,"dnd")
	table.insert(plist,"ss")
	table.insert(plist,"fes")
	table.insert(plist,"dc")
	table.insert(plist,"how")
	table.insert(plist,"end")

	cfg.plist=plist

	cfg.case = {}
	cfg.case = {
		["Outbreak_bp"] = function()
			return lib.BuffApply("Outbreak","bp")
		end,
		["Outbreak_ff"] = function()
			return lib.BuffApply("Outbreak","ff")
		end,
		["ps"] = function()
			return lib.BuffApply("ps","bp",true)
		end,
		["it"] = function()
			return lib.BuffApply("it","ff",true)
		end,
		["dt"] = function ()
			return lib.ApplyonAura("dt","si",5)
		end,
		["dc_sd"] = function ()
			return lib.ApplyonAura("dc","sd")
		end,
			["dnd"] = function ()
				return lib.SimpleCDCheck("dnd")
			end,
		["ss"] = function ()
			return lib.SimpleCDCheck("ss",true)
		end,
		["fes"] = function ()
			return lib.SimpleCDCheck("fes",true)
		end,
		["dc"] = function ()
			return lib.SimpleCDCheck("dc")
		end,
		["how"] = function ()
			return lib.SimpleCDCheck("how")
		end,
		["end"] = function ()
			if cfg.cmintime~=9999999 then return nil end
		end,
	}

	return true
end

lib.classes["DEATHKNIGHT"][2] = function ()

	cfg.spells={}
	lib.AddSpell("Outbreak",{77575}) -- Outbreak
	
	lib.AddRuneSpell("ps",{45462},{0,1,0}) -- Plague Strike
	lib.AddRuneSpell("hb",{49184},{0,0,1}) -- Howling Blast
	lib.AddRuneSpell("ob",{49020},{0,1,1}) -- Obliterate
--	lib.AddRuneSpell("bs",{45902},{1,0,0}) -- Blood Strike
	lib.AddRuneSpell("dnd",{43265},{0,1,0}) -- Death and Decay
	lib.AddRuneSpell("pillar",{51271},{0,0,1}) -- Pillar of Frost
	
	lib.AddSpell("erw",{47568}) -- Empower Rune Weapon
	lib.AddSpell("tap",{45529}) -- Blood Tap
	lib.AddSpell("fs",{49143}) -- Frost Strike
	lib.AddSpell("how",{57330}) -- Horn of Winter
	lib.AddSpell("pest",{50842}) -- Pestilence
				
	cfg.auras={}
	lib.AddAura("rime",59052,"buff","player") -- Freezing Fog
	lib.AddAura("km",51124,"buff","player") -- Killing Machine
	lib.AddAura("bp",55078,"debuff","target") -- Blood Plague
	lib.AddAura("ff",55095,"debuff","target") -- Frost Fever
		
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Outbreak_bp")
	table.insert(cfg.plistdps,"Outbreak_ff")
	table.insert(cfg.plistdps,"hb_ff")
	table.insert(cfg.plistdps,"ps_bp")
	table.insert(cfg.plistdps,"pillar")
	table.insert(cfg.plistdps,"ob_km")
--	table.insert(cfg.plistdps,"fs_cap")
	table.insert(cfg.plistdps,"hb_rime")
	table.insert(cfg.plistdps,"ob")
	table.insert(cfg.plistdps,"fs_nokm")
	table.insert(cfg.plistdps,"how")
	table.insert(cfg.plistdps,"erw")
	table.insert(cfg.plistdps,"tap")
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"pillar")
	table.insert(cfg.plistaoe,"dnd")
	table.insert(cfg.plistaoe,"hb")
	table.insert(cfg.plistaoe,"fs")
	table.insert(cfg.plistaoe,"tap")
	table.insert(cfg.plistaoe,"erw")
	table.insert(cfg.plistaoe,"ps_aoe")
	table.insert(cfg.plistaoe,"how")
	table.insert(cfg.plistaoe,"end")

	cfg.plist=cfg.plistdps
	
	cfg.case = {}
	cfg.case = {
		["fs_nokm"] = function()
			local t = lib.GetAura({"km"})
			if (t>0 and lib.SpellTL("ob")>2) or t==0 then
				return lib.SimpleCDCheck("fs")
			end
			return nil
		end,
		["erw"] = function()
			if cfg.cmintime>=3 then
				return lib.SimpleCDCheck("erw")
			end
			return nil
		end,
		["tap"] = function()
			if cfg.cmintime>=2 then
				return lib.SimpleCDCheck("tap")
			end
			return nil
		end,
		["Outbreak_bp"] = function()
			local t = lib.GetAura({"bp"})
			if t < 3 then 
				return lib.SimpleCDCheck("Outbreak")
			end
			return nil
		end,
		["Outbreak_ff"] = function()
			local t = lib.GetAura({"ff"})
			if t < 3 then 
				return lib.SimpleCDCheck("Outbreak")
			end
			return nil
		end,
		["ps_bp"] = function()
			local t = lib.GetAura({"bp"})
			if t<3 then
				return lib.RuneCDCheck("ps",true)
			end
			return nil
		end,
		["ps_aoe"] = function()
			local t = lib.GetAura({"bp"})
			if t<3 then
				return lib.RuneCDCheck("ps")
			end
			return nil
		end,
		["hb"] = function ()
			local t = lib.GetAura({"rime"})
			if t > 0 then 
				return lib.SimpleCDCheck("hb")
			end
			return lib.RuneCDCheck("hb",true)
		end,
		["hb_ff"] = function()
			local t = lib.GetAura({"ff"})
			if t<3 then
				return cfg.case["hb"]()
			end
			return nil
		end,
		["hb_rime"] = function ()
			local t = lib.GetAura({"rime"})
			if t > 0 then 
				return lib.SimpleCDCheck("hb")
			end
			return nil
		end,
		["ob_km"] = function ()
			local t = lib.GetAura({"km"})
			if t > 0 then 
				return lib.RuneCDCheck("ob",true)
			end
			return nil
		end,
		["ob"] = function ()
			return lib.RuneCDCheck("ob",true)
		end,
		["how"] = function ()
			if cfg.power<cfg.spells["fs"].powerCost then
				return lib.SimpleCDCheck("how")
			end
			return nil
		end,
		["dnd"] = function ()
			return lib.RuneCDCheck("dnd",true)
		end,
		["pillar"] = function ()
			return lib.RuneCDCheck("pillar",true)
		end,
		["end"] = function ()
			if cfg.cmintime~=cfg.maxmintime then return nil end
			lib.UpdateBar(nil)
		end,
	}
	
--[[	lib.myonruneupdate=function(rune)
		if rune and rune<=2 and cfg.runes[rune].runeType~=4 then
			print("Please logout - Blizzard broke blood runes")
		end
	end]]
	
	cfg.mode = "dps"
	
	lib.onclick = function()
		if cfg.mode == "dps" then
			cfg.mode = "aoe"
			cfg.plist=cfg.plistaoe
			cfg.Update=true
		else
			cfg.mode = "dps"
			cfg.plist=cfg.plistdps
			cfg.Update=true
		end
		print(cfg.mode)
	end
	
	lib.rangecheck=function()
		if lib.inrange("fs") then
			lib.bdcolor(Heddframe.bd,nil)
		elseif lib.inrange("hb") then
			lib.bdcolor(Heddframe.bd,{0,0,1,1})
		else
			lib.bdcolor(Heddframe.bd,{1,0,0,1})
		end
	end
	
	return true
end

lib.classes["DEATHKNIGHT"][1] = function ()

	cfg.spells={}
	lib.AddSpell("Outbreak",{77575}) -- Outbreak
--	lib.AddSpell("melee",{6603}) -- Melee
	
	lib.AddRuneSpell("ps",{45462},{0,1,0}) -- Plague Strike
	lib.AddRuneSpell("it",{45477},{0,0,1}) -- Icy Touch
--	lib.AddRuneSpell("hb",{49184},{0,0,1}) -- Howling Blast
--	lib.AddRuneSpell("ob",{49020},{0,1,1}) -- Obliterate
	lib.AddRuneSpell("ds",{49998},{0,1,1}) -- Death Strike
--	lib.AddRuneSpell("bs",{45902},{1,0,0}) -- Blood Strike
	lib.AddRuneSpell("hs",{55050},{1,0,0}) -- Heart Strike
	lib.AddRuneSpell("bb",{48721},{1,0,0}) -- Blood Boil
	lib.AddRuneSpell("dnd",{43265},{0,1,0}) -- Death and Decay
--	lib.AddRuneSpell("pillar",{51271},{0,0,1}) -- Pillar of Frost
	
	lib.AddSpell("erw",{47568}) -- Empower Rune Weapon
	lib.AddSpell("tap",{45529}) -- Blood Tap
--	lib.AddSpell("fs",{49143}) -- Frost Strike
	lib.AddSpell("rs",{56815}) -- Rune Strike
	lib.AddSpell("dc",{47541}) -- Death Coil
	lib.AddSpell("how",{57330}) -- Horn of Winter
	lib.AddSpell("pest",{50842}) -- Pestilence
	cfg.lastpest=0
	
	cfg.auras={}
--	lib.AddAura("rime",59052,"buff","player") -- Freezing Fog
--	lib.AddAura("km",51124,"buff","player") -- Killing Machine
	lib.AddAura("cs",81141,"buff","player") -- Crimson Scourge
	
	lib.AddAura("bp",55078,"debuff","target") -- Blood Plague
	lib.AddAura("ff",55095,"debuff","target") -- Frost Fever
		
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Outbreak_ff")
	table.insert(cfg.plistdps,"Outbreak_bp")
	table.insert(cfg.plistdps,"it_ff")
	table.insert(cfg.plistdps,"ps_bp")
	table.insert(cfg.plistdps,"ds_new")
	table.insert(cfg.plistdps,"hs_new")
	table.insert(cfg.plistdps,"ds")
	table.insert(cfg.plistdps,"hs_max")
	table.insert(cfg.plistdps,"rs")
	table.insert(cfg.plistdps,"bb_cs")
	table.insert(cfg.plistdps,"how")
	table.insert(cfg.plistdps,"erw")
	table.insert(cfg.plistdps,"tap")
	table.insert(cfg.plistdps,"end")
	
	cfg.plistdef = {}
	table.insert(cfg.plistdef,"Outbreak_ff")
	table.insert(cfg.plistdef,"Outbreak_bp")
	table.insert(cfg.plistdef,"it_ff")
	table.insert(cfg.plistdef,"ps_bp")
	table.insert(cfg.plistdef,"ds_new")
	table.insert(cfg.plistdef,"hs_new")
	table.insert(cfg.plistdef,"ds_max")
	table.insert(cfg.plistdef,"hs")
	table.insert(cfg.plistdef,"rs")
	table.insert(cfg.plistdef,"bb_cs")
	table.insert(cfg.plistdef,"how")
	table.insert(cfg.plistdef,"erw")
	table.insert(cfg.plistdef,"tap")
	table.insert(cfg.plistdef,"end")
	
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"dnd")
	table.insert(cfg.plistaoe,"Outbreak_ff")
	table.insert(cfg.plistaoe,"Outbreak_bp")
	table.insert(cfg.plistaoe,"it_ff")
	table.insert(cfg.plistaoe,"ps_bp")
	table.insert(cfg.plistaoe,"pest")
	table.insert(cfg.plistaoe,"bb")
	table.insert(cfg.plistaoe,"rs")
	table.insert(cfg.plistaoe,"tap")
	table.insert(cfg.plistaoe,"ds")
	table.insert(cfg.plistaoe,"how")
	table.insert(cfg.plistaoe,"end")

	cfg.plist=cfg.plistdps
	
	cfg.case = {}
	cfg.case = {
		["erw"] = function()
			if cfg.cmintime>=3 then
				return lib.SimpleCDCheck("erw")
			end
			return nil
		end,
		["tap"] = function()
			if cfg.cmintime>=2 then
				return lib.SimpleCDCheck("tap")
			end
			return nil
		end,
		["Outbreak_bp"] = function()
			local t = lib.GetAura({"bp"})
			if t < 3 then 
				return lib.SimpleCDCheck("Outbreak")
			end
			return nil
		end,
		["Outbreak_ff"] = function()
			local t = lib.GetAura({"ff"})
			if t < 3 then 
				return lib.SimpleCDCheck("Outbreak")
			end
			return nil
		end,
		["ps_bp"] = function()
			local t = lib.GetAura({"bp"})
			if t<3 then
				return lib.RuneCDCheck("ps",true)
			end
			return nil
		end,
		["it_ff"] = function()
			local t = lib.GetAura({"ff"})
			if t<3 then
				return lib.RuneCDCheck("it",true)
			end
			return nil
		end,
		["pest"] = function()
			if cfg.now>(cfg.lastpest+cfg.destime-2) and lib.GetAura({"bp"})>0 and lib.GetAura({"ff"})>0 then
				return lib.RuneCDCheck("pest",true)
			end
			return nil
		end,
		["ds_new"] = function ()
			return lib.RuneCDCheck("ds",true,true)
		end,
		["ds"] = function ()
			return lib.RuneCDCheck("ds")
		end,
		["ds_max"] = function ()
			return lib.RuneCDCheck("ds",true)
		end,
		["hs_new"] = function ()
			return lib.RuneCDCheck("hs",nil,true)
		end,
		["hs"] = function ()
			return lib.RuneCDCheck("hs")
		end,
		["hs_max"] = function ()
			return lib.RuneCDCheck("hs",true)
		end,
		["bb"] = function ()
			local t = lib.GetAura({"cs"})
			if t > 0 then 
				return lib.SimpleCDCheck("bb")
			end
			return lib.RuneCDCheck("bb",true)
		end,
		["bb_cs"] = function ()
			local t = lib.GetAura({"cs"})
			if t > 0 then 
				return lib.SimpleCDCheck("bb")
			end
			return nil
		end,
		["how"] = function ()
			if cfg.power<cfg.spells["rs"].powerCost then
				return lib.SimpleCDCheck("how")
			end
			return nil
		end,
		["dnd"] = function ()
			return lib.RuneCDCheck("dnd")
		end,
		["end"] = function ()
			if cfg.cmintime~=cfg.maxmintime then return nil end
			lib.UpdateBar(nil)
		end,
	}

--[[	lib.myonruneupdate=function(rune)
		if rune and rune<=2 and cfg.runes[rune].runeType~=4 then
			print("Please logout - Blizzard broke blood runes")
		end
	end]]
	
	cfg.mode = "dps"
	
	lib.onclick = function()
		if cfg.mode == "dps" then
			cfg.mode = "def"
			cfg.plist=cfg.plistdef
			cfg.Update=true
		elseif cfg.mode == "def" then
			cfg.mode = "aoe"
			cfg.plist=cfg.plistaoe
			cfg.Update=true
		else
			cfg.mode = "dps"
			cfg.plist=cfg.plistdps
			cfg.Update=true
		end
		print(cfg.mode)
	end
	
	lib.rangecheck=function()
		if lib.inrange("rs") then
			lib.bdcolor(Heddframe.bd,nil)
		elseif lib.inrange("it") then
			lib.bdcolor(Heddframe.bd,{0,0,1,1})
		elseif lib.inrange("dc") then
			lib.bdcolor(Heddframe.bd,{0,1,0,1})
		else
			lib.bdcolor(Heddframe.bd,{1,0,0,1})
		end
	end
	
	return true
end

lib.classevents["DEATHKNIGHT"] = function()
	cfg.destime=21
	cfg.rpmax=100
	
	lib.mypew=lib.updateAllRunes
	
	lib.myonupdate = function()
		lib.rangecheck()
		if lib.updateAllRunes() then
			cfg.Update=true
		end
	end
	
	if cfg.hiderunes then lib.hideRuneFrame() end
	
	function Heddevents:PLAYER_UNGHOST()
		if lib.updateAllRunes() then
			cfg.Update=true
		end
	end
	
	function Heddevents:RUNE_POWER_UPDATE(rune)
		if rune and rune>0 and rune<6 then
			if lib.updateRune(rune) then
				cfg.Update=true
			end
		end
	end
	
	function Heddevents:RUNE_TYPE_UPDATE(rune)
		if rune and rune>0 and rune<6 then
			if lib.updateRune(rune) then
				cfg.Update=true
			end
		end
	end
	
	function Heddevents:UNIT_SPELLCAST_SUCCEEDED(unit,spell)
		if unit=="player" and spell==cfg.spells["pest"].name then
			cfg.now = GetTime()
			cfg.lastpest=cfg.now
			cfg.Update=true
		end
	end
	
	lib.mytal = function()
		local nameTalent, icon, tier, column, currRank, maxRank= GetTalentInfo(3,3)
		cfg.destime = (21+4*currRank)
		nameTalent, icon, tier, column, currRank, maxRank= GetTalentInfo(2,1)
		cfg.rpmax = (100+10*currRank)
	end
	
	cfg.onupdate=true
	cfg.onpower=true
end